using System;
using System.CodeDom;
using System.CodeDom.Compiler;
using System.Collections;
using System.Collections.Specialized;
using System.Configuration;
using System.IO;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using Microsoft.VisualBasic;

namespace DevSummit
{
	/// <summary>
	/// Config ̊Tv̐łB
	/// </summary>
	public class Config
	{
		private static string[] assemblies;

		static Config()
		{
			StringCollection sc = new StringCollection();
			Assembly mainAssembly = Assembly.GetExecutingAssembly();
			addAssembly(mainAssembly, sc);
			foreach (AssemblyName an in mainAssembly.GetReferencedAssemblies())
			{
				addAssembly(Assembly.Load(an), sc);
			}
			assemblies = new string[sc.Count];
			sc.CopyTo(assemblies, 0);
		}

		static void addAssembly(Assembly asm, StringCollection sc)
		{
			foreach (Module m in asm.GetModules())
			{
				if (!sc.Contains(m.Name))
				{
					sc.Add(m.Name);
				}
			}
		}
		
		public Config()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}
		const int LINE_OFFSET = 4;
		public void Apply(Configurable conf)
		{
			NameValueCollection nv = ConfigurationSettings.AppSettings;
			StringBuilder sb = new StringBuilder();
			using (StreamReader sr = new StreamReader(nv["configfile"], Encoding.Default))
			{
				sb.Append("Imports System\r\n");
				sb.Append("Imports DevSummit\r\n");
				sb.Append("Public Class Foo\r\n");
				sb.Append("Public Shared Sub foo(ByVal conf As Configurable)\r\n");
				sb.Append(sr.ReadToEnd());
				sb.Append("\r\nEnd Sub");
				sb.Append("\r\nEnd Class\r\n");
			}
			ICodeCompiler compiler = new VBCodeProvider().CreateCompiler();
			CompilerParameters prms = new CompilerParameters();
			prms.GenerateInMemory = true;
			prms.IncludeDebugInformation = true;
			prms.ReferencedAssemblies.AddRange(assemblies);
			CompilerResults rts = compiler.CompileAssemblyFromSource(prms, sb.ToString());
			if (rts.Errors.Count > 0)
			{
				StringBuilder esb = new StringBuilder();
				foreach (CompilerError e in rts.Errors)
				{
					esb.Append((e.Line - LINE_OFFSET) + ":" + e.ErrorText + "\r\n");
				}
				MessageBox.Show(esb.ToString());
			}
			else
			{
				Assembly asm = rts.CompiledAssembly;
				Type cls = asm.GetType("Foo");
				MethodInfo mi = cls.GetMethod("foo");
				Object[] args = new Object[] { conf };
				mi.Invoke(null, args);
			}

		}

	}
}
